#! /usr/bin/python

from pylab import *
import sys



def thd(x):
    n = len(x)
    X = abs(fft(x)) / n
    X1rms2 = 2 * X[1] ** 2
    Xrms2 = sum(X ** 2)
    return 100 * sqrt(Xrms2 / X1rms2 - 1)
    
def rms(x):
    return sqrt(mean(x ** 2))
    
def apower(x, y):
    return mean(x * y)

def dpf(x, y):
    X = fft(x)
    Y = fft(y)
    return cos(angle(X[1]) - angle(Y[1]))
    
    
    
# it starts here

# specify the measurement
s = sys.argv[1]
what = False
while (not what):
    if   s == 'a':
        ioutstring = r'$I_{OUT} = 0.7 \, \text{A}$'
        what = True
    elif s == 'b':
        ioutstring = r'$I_{OUT} = 1 \, \text{A}$'
        what = True
    elif s == 'c':
        ioutstring = r'$I_{OUT} = 1.5 \, \text{A}$'
        what = True
    elif s == 'd':
        ioutstring = r'$I_{OUT} = 2 \, \text{A}$'
        what = True
    else:
        print 'wrong measurement set "' + s + '", try again . . .'
        print
        s = raw_input('measurement set: ')

# load the data
print '    loading the data . . .'

i1 = np.load(s + '1i.npy')
v11 = np.load(s + '1v.npy')
i2 = np.load(s + '2i.npy')
v21 = np.load(s + '2v.npy')
i3 = np.load(s + '3i.npy')
v31 = np.load(s + '3v.npy')

ita1 = np.load(s + '4i.npy')
v12 = np.load(s + '4v.npy')
ita2 = np.load(s + '5i.npy')
v22 = np.load(s + '5v.npy')
ita3 = np.load(s + '6i.npy')
v32 = np.load(s + '6v.npy')

itb1 = np.load(s + '7i.npy')
v13= np.load(s + '7v.npy')
itb2 = np.load(s + '8i.npy')
v23 = np.load(s + '8v.npy')
itb3 = np.load(s + '9i.npy')
v33 = np.load(s + '9v.npy')

ira1 = np.load(s + '10i.npy')
va1 = np.load(s + '10v.npy')
ira2 = np.load(s + '11i.npy')
va2 = np.load(s + '11v.npy')
ira3 = np.load(s + '12i.npy')
va3 = np.load(s + '12v.npy')

irb1 = np.load(s + '13i.npy')
vb1 = np.load(s + '13v.npy')
irb2 = np.load(s + '14i.npy')
vb2 = np.load(s + '14v.npy')
irb3 = np.load(s + '15i.npy')
vb3 = np.load(s + '15v.npy')

iout1 = np.load(s + '16i.npy')
vouta = np.load(s + '16v.npy')
iout2 = np.load(s + '17i.npy')
voutb = np.load(s + '17v.npy')
iout3 = np.load(s + '18i.npy')
vout = np.load(s + '18v.npy')



# computing
print '    computing . . .'



# input

thdi1 = thd(i1)
thdi2 = thd(i2)
thdi3 = thd(i3)

thdv11 = thd(v11)
thdv21 = thd(v21)
thdv31 = thd(v31)

P1 = apower(i1, v11)
P2 = apower(i2, v21)
P3 = apower(i3, v31)

I1rms = rms(i1)
I2rms = rms(i2)
I3rms = rms(i3)

V11rms = rms(v11)
V21rms = rms(v21)
V31rms = rms(v31)

S1 = I1rms * V11rms
S2 = I2rms * V21rms
S3 = I3rms * V31rms

PF1 = P1 / S1
PF2 = P2 / S2
PF3 = P3 / S3

DPF1 = dpf(i1, v11)
DPF2 = dpf(i2, v21)
DPF3 = dpf(i3, v31)

P = P1 + P2 + P3



# transformer A

thdita1 = thd(ita1)
thdita2 = thd(ita2)
thdita3 = thd(ita3)

thdv12 = thd(v12)
thdv22 = thd(v22)
thdv32 = thd(v32)

Pta1 = apower(ita1, v12)
Pta2 = apower(ita2, v22)
Pta3 = apower(ita3, v32)

Ita1rms = rms(ita1)
Ita2rms = rms(ita2)
Ita3rms = rms(ita3)

V12rms = rms(v12)
V22rms = rms(v22)
V32rms = rms(v32)

Sta1 = Ita1rms * V12rms
Sta2 = Ita2rms * V22rms
Sta3 = Ita3rms * V32rms

PFta1 = Pta1 / Sta1
PFta2 = Pta2 / Sta2
PFta3 = Pta3 / Sta3

DPFta1 = dpf(ita1, v12)
DPFta2 = dpf(ita2, v22)
DPFta3 = dpf(ita3, v32)

Pta = Pta1 + Pta2 + Pta3



# transformer B

thditb1 = thd(itb1)
thditb2 = thd(itb2)
thditb3 = thd(itb3)

thdv13 = thd(v13)
thdv23 = thd(v23)
thdv33 = thd(v33)

Ptb1 = apower(itb1, v13)
Ptb2 = apower(itb2, v23)
Ptb3 = apower(itb3, v33)

Itb1rms = rms(itb1)
Itb2rms = rms(itb2)
Itb3rms = rms(itb3)

V13rms = rms(v13)
V23rms = rms(v23)
V33rms = rms(v33)

Stb1 = Itb1rms * V13rms
Stb2 = Itb2rms * V23rms
Stb3 = Itb3rms * V33rms

PFtb1 = Ptb1 / Stb1
PFtb2 = Ptb2 / Stb2
PFtb3 = Ptb3 / Stb3

DPFtb1 = dpf(itb1, v13)
DPFtb2 = dpf(itb2, v23)
DPFtb3 = dpf(itb3, v33)

Ptb = Ptb1 + Ptb2 + Ptb3



# rectifier A

thdira1 = thd(ira1)
thdira2 = thd(ira2)
thdira3 = thd(ira3)

thdva1 = thd(va1)
thdva2 = thd(va2)
thdva3 = thd(va3)

Pra1 = apower(ira1, va1)
Pra2 = apower(ira2, va2)
Pra3 = apower(ira3, va3)

Ira1rms = rms(ira1)
Ira2rms = rms(ira2)
Ira3rms = rms(ira3)

Va1rms = rms(va1)
Va2rms = rms(va2)
Va3rms = rms(va3)

Sra1 = Ira1rms * Va1rms
Sra2 = Ira2rms * Va2rms
Sra3 = Ira3rms * Va3rms

PFra1 = Pra1 / Sra1
PFra2 = Pra2 / Sra2
PFra3 = Pra3 / Sra3

DPFra1 = dpf(ira1, va1)
DPFra2 = dpf(ira2, va2)
DPFra3 = dpf(ira3, va3)

Pra = Pra1 + Pra2 + Pra3

effta = Pra / Pta * 100



# rectifier B

thdirb1 = thd(irb1)
thdirb2 = thd(irb2)
thdirb3 = thd(irb3)

thdvb1 = thd(vb1)
thdvb2 = thd(vb2)
thdvb3 = thd(vb3)

Prb1 = apower(irb1, vb1)
Prb2 = apower(irb2, vb2)
Prb3 = apower(irb3, vb3)

Irb1rms = rms(irb1)
Irb2rms = rms(irb2)
Irb3rms = rms(irb3)

Vb1rms = rms(vb1)
Vb2rms = rms(vb2)
Vb3rms = rms(vb3)

Srb1 = Irb1rms * Vb1rms
Srb2 = Irb2rms * Vb2rms
Srb3 = Irb3rms * Vb3rms

PFrb1 = Prb1 / Srb1
PFrb2 = Prb2 / Srb2
PFrb3 = Prb3 / Srb3

DPFrb1 = dpf(irb1, vb1)
DPFrb2 = dpf(irb2, vb2)
DPFrb3 = dpf(irb3, vb3)

Prb = Prb1 + Prb2 + Prb3

efftb = Prb / Ptb * 100



# output

Pouta = apower(iout1, vouta)
Poutb = apower(iout2, voutb)
Pout = apower(iout3, vout)

Iout1 = mean(iout1)
Iout2 = mean(iout2)
Iout3 = mean(iout3)

Vouta = mean(vouta)
Voutb = mean(voutb)
Vout = mean(vout)

effra = Pouta / Pra * 100

effrb = Poutb / Prb * 100

eff = Pout / P * 100



# losses
Plta = Pta - Pra
Pltb = Ptb - Prb
Plra = Pra - Pouta
Plrb = Prb - Poutb
SPl = Plta + Pltb + Plra + Plrb
Pl = P - Pout



# inconsistencies
DPin = P - Pta - Ptb
DPout = Pout - Pouta - Poutb
DPl = Pl - SPl



# printout
print '    formatting tables . . .'

f = open('tables-' + s + '-12-pulse.tex', 'w')

# input
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', input}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(V11rms, V21rms, V31rms) + '\n')
f.write(r'$T\!H\!D \left( v_k \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdv11, thdv21, thdv31) + '\n')
f.write(r'$I_{k \, RMS} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(I1rms, I2rms, I3rms) + '\n')
f.write(r'$T\!H\!D \left( i_k \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdi1, thdi2, thdi3) + '\n')
f.write(r'$P_k \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(P1, P2, P3) + '\n')
f.write(r'$S_k \; [\text{VA}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(S1, S2, S3) + '\n')
f.write(r'$P\!F_k$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(PF1, PF2, PF3) + '\n')
f.write(r'$D\!P\!F_k$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(DPF1, DPF2, DPF3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}
''')
#f.write(r'$P_{IN} = ' + r'{:.2f}'.format(P) + r' \, \text{W}$' + '\n')

f.write('''

''')

f.write(r'\clearpage' + '\n')

# transformer A
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', transformer A}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(V12rms, V22rms, V32rms) + '\n')
f.write(r'$T\!H\!D \left( v_k \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdv12, thdv22, thdv32) + '\n')
f.write(r'$I_{T\!A \, k \, RMS} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Ita1rms, Ita2rms, Ita3rms) + '\n')
f.write(r'$T\!H\!D \left( i_{T\!A \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdita1, thdita2, thdita3) + '\n')
f.write(r'$P_{T\!A \, k} \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Pta1, Pta2, Pta3) + '\n')
f.write(r'$S_{T\!A \, k} \; [\text{VA}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Sta1, Sta2, Sta3) + '\n')
f.write(r'$P\!F_{T\!A \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(PFta1, PFta2, PFta3) + '\n')
f.write(r'$D\!P\!F_{T\!A \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(DPFta1, DPFta2, DPFta3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}
''')
#f.write(r'$P_{T\!A} = ' + r'{:.2f}'.format(Pta) + r' \, \text{W}$' + '\n')

f.write('''

''')

# transformer B
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', transformer B}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(V13rms, V23rms, V33rms) + '\n')
f.write(r'$T\!H\!D \left( v_k \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdv13, thdv23, thdv33) + '\n')
f.write(r'$I_{T\!B \, k \, RMS} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Itb1rms, Itb2rms, Itb3rms) + '\n')
f.write(r'$T\!H\!D \left( i_{T\!B \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thditb1, thditb2, thditb3) + '\n')
f.write(r'$P_{T\!B \, k} \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Ptb1, Ptb2, Ptb3) + '\n')
f.write(r'$S_{T\!B \, k} \; [\text{VA}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Stb1, Stb2, Stb3) + '\n')
f.write(r'$P\!F_{T\!B \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(PFtb1, PFtb2, PFtb3) + '\n')
f.write(r'$D\!P\!F_{T\!B \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(DPFtb1, DPFtb2, DPFtb3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}
''')
#f.write(r'$P_{T\!B} = ' + r'{:.2f}'.format(Ptb) + r' \, \text{W}$' + '\n')

f.write('''

''')

f.write(r'\clearpage' + '\n')

# rectifier A
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', rectifier A}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{A \, k \, RMS} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Va1rms, Va2rms, Va3rms) + '\n')
f.write(r'$T\!H\!D \left( v_{A \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdva1, thdva2, thdva3) + '\n')
f.write(r'$I_{RA \, k \, RMS} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Ira1rms, Ira2rms, Ira3rms) + '\n')
f.write(r'$T\!H\!D \left( i_{RA \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdira1, thdira2, thdira3) + '\n')
f.write(r'$P_{RA \, k} \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Pra1, Pra2, Pra3) + '\n')
f.write(r'$S_{RA \, k} \; [\text{VA}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Sra1, Sra2, Sra3) + '\n')
f.write(r'$P\!F_{RA \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(PFra1, PFra2, PFra3) + '\n')
f.write(r'$D\!P\!F_{RA \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(DPFra1, DPFra2, DPFra3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}
''')
#f.write(r'$P_{RA} = ' + r'{:.2f}'.format(Pra) + r' \, \text{W}$' + '\n')

f.write('''

''')

# rectifier B
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', rectifier B}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{B \, k \, RMS} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Vb1rms, Vb2rms, Vb3rms) + '\n')
f.write(r'$T\!H\!D \left( v_{B \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdvb1, thdvb2, thdvb3) + '\n')
f.write(r'$I_{RB \, k \, RMS} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Irb1rms, Irb2rms, Irb3rms) + '\n')
f.write(r'$T\!H\!D \left( i_{RB \, k} \right) \; [\%]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(thdirb1, thdirb2, thdirb3) + '\n')
f.write(r'$P_{RB \, k} \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Prb1, Prb2, Prb3) + '\n')
f.write(r'$S_{RB \, k} \; [\text{VA}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Srb1, Srb2, Srb3) + '\n')
f.write(r'$P\!F_{RB \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(PFrb1, PFrb2, PFrb3) + '\n')
f.write(r'$D\!P\!F_{RB \, k}$ & ' + r'{:.4f} & {:.4f} & {:.4f} \\'.format(DPFrb1, DPFrb2, DPFrb3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}
''')
#f.write(r'$P_{RB} = ' + r'{:.2f}'.format(Prb) + r' \, \text{W}$' + '\n')

f.write('''

''')

# output
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{''' + ioutstring + r''', output}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
output & rectifier A & rectifier B & complete output \\
\hline
''')
#
f.write(r'$I_{OUT} \; [\text{A}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Iout1, Iout1, Iout3) + '\n')
f.write(r'$V_{OUT} \; [\text{V}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Vouta, Voutb, Vout) + '\n')
f.write(r'$P_{OUT} \; [\text{W}]$ & ' + r'{:.2f} & {:.2f} & {:.2f} \\'.format(Pouta, Poutb, Pout) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}


''')

f.write(r'\clearpage' + '\n')

# power
f.write(r'''

\bigskip
\noindent
Snage:

\begin{enumerate}
''')
f.write(r'\item $P_{I\!N} = ' + r'{:.2f}'.format(P) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{T\!A} = ' + r'{:.2f}'.format(Pta) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{T\!B} = ' + r'{:.2f}'.format(Ptb) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{RA} = ' + r'{:.2f}'.format(Pra) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{RB} = ' + r'{:.2f}'.format(Prb) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{OUTA} = ' + r'{:.2f}'.format(Pouta) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{OUTB} = ' + r'{:.2f}'.format(Poutb) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{OUT} = ' + r'{:.2f}'.format(Pout) + r' \, \text{W}$' + '\n')
f.write(r'''\end{enumerate}
''')

# losses
f.write(r'''

\bigskip
\noindent
Gubici:

\begin{enumerate}
''')
f.write(r'\item $P_{loss\,T\!A} = ' + r'{:.2f}'.format(Plta) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{loss\,T\!B} = ' + r'{:.2f}'.format(Pltb) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{loss\,RA} = ' + r'{:.2f}'.format(Plra) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{loss\,RB} = ' + r'{:.2f}'.format(Plrb) + r' \, \text{W}$' + '\n')
f.write(r'\item $P_{loss} = P_{IN} - P_{OUT} = ' + r'{:.2f}'.format(Pl) + r' \, \text{W}$' + '\n')
f.write(r'''\end{enumerate}
''')

# efficiency
f.write(r'''

\bigskip
\noindent
Koeficijenti korisnog dejstva:

\begin{enumerate}
''')
f.write(r'\item $\eta_{T\!A} = ' + r'{:.2f}'.format(effta) + r' \%$' + '\n')
f.write(r'\item $\eta_{T\!B} = ' + r'{:.2f}'.format(efftb) + r' \%$' + '\n')
f.write(r'\item $\eta_{RA} = ' + r'{:.2f}'.format(effra) + r' \%$' + '\n')
f.write(r'\item $\eta_{RB} = ' + r'{:.2f}'.format(effrb) + r' \%$' + '\n')
f.write(r'\item $\eta = ' + r'{:.2f}'.format(eff) + r' \%$' + '\n')
f.write(r'''\end{enumerate}
''')

# inconsistencies
f.write(r'''

\bigskip
\noindent
Nekonzistentnosti u snagama:

\begin{enumerate}
''')
f.write(r'\item $\Delta P_{IN} = P_{IN} - P_{T\!A} - P_{T\!B} = ' + r'{:.2f}'.format(DPin) + r' \, \text{W}$' + '\n')
f.write(r'\item $\Delta P_{OUT} = P_{OUT} - P_{OUTA} - P_{OUTB} = ' + r'{:.2f}'.format(DPout) + r' \, \text{W}$' + '\n')
f.write(r'\item $\Delta P_{loss} = P_{IN} - P_{OUT} - \Sigma P_{loss} = ' + r'{:.2f}'.format(DPl) + r' \, \text{W}$' + '\n')
f.write(r'''\end{enumerate}
''')

f.close()



# results
print '    saving the results . . .'

thdiresults = [thdi1, thdi2, thdi3, thdita1, thdita2, thdita3, thditb1, thditb2, thditb3, thdira1, thdira2, thdira3, thdirb1, thdirb2, thdirb3]
thdvresults = [thdv11, thdv21, thdv31, thdv12, thdv22, thdv32, thdv13, thdv23, thdv33, thdva1, thdva2, thdva3, thdvb1, thdvb2, thdvb3]
rmsvresults = [V11rms, V21rms, V31rms, V12rms, V22rms, V32rms, V13rms, V23rms, V33rms, Va1rms, Va2rms, Va3rms, Vb1rms, Vb2rms, Vb3rms]
rmsiresults = [I1rms, I2rms, I3rms, Ita1rms, Ita2rms, Ita3rms, Itb1rms, Itb2rms, Itb3rms, Ira1rms, Ira2rms, Ira3rms, Irb1rms, Irb2rms, Irb3rms]
Presults = [P1, P2, P3, Pta1, Pta2, Pta3, Ptb1, Ptb2, Ptb3, Pra1, Pra2, Pra3, Prb1, Prb2, Prb3]
Sresults = [S1, S2, S3, Sta1, Sta2, Sta3, Stb1, Stb2, Stb3, Sra1, Sra2, Sra3, Srb1, Srb2, Srb3]
PFresults = [PF1, PF2, PF3, PFta1, PFta2, PFta3, PFtb1, PFtb2, PFtb3, PFra1, PFra2, PFra3, PFrb1, PFrb2, PFrb3]
DPFresults = [DPF1, DPF2, DPF3, DPFta1, DPFta2, DPFta3, DPFtb1, DPFtb2, DPFtb3, DPFra1, DPFra2, DPFra3, DPFrb1, DPFrb2, DPFrb3]
outresults = [Iout1, Iout2, Iout3, Vouta, Voutb, Vout, Pouta, Poutb, Pout]

np.save(s + '-thdiresults', thdiresults)
np.save(s + '-thdvresults', thdvresults)
np.save(s + '-rmsvresults', rmsvresults)
np.save(s + '-rmsiresults', rmsiresults)
np.save(s + '-Presults', Presults)
np.save(s + '-Sresults', Sresults)
np.save(s + '-PFresults', PFresults)
np.save(s + '-DPFresults', DPFresults)
np.save(s + '-outresults', outresults)

print '    done!'

