#! /usr/bin/python

from pylab import *
   
def thd(x):
    n = len(x)
    X = abs(fft(x)) / n
    X1rms2 = 2 * X[1] ** 2
    Xrms2 = sum(X ** 2)
    return 100 * sqrt(Xrms2 / X1rms2 - 1)
    
def rms(x):
    return sqrt(mean(x ** 2))
    
def apower(x, y):
    return mean(x * y)

def dpf(x, y):
    X = fft(x)
    Y = fft(y)
    return cos(angle(X[1]) - angle(Y[1]))
    


# let's start here . . .

print '    initialize . . .'

i1 = np.load('o1i.npy')
i2 = np.load('o2i.npy')
i3 = np.load('o3i.npy')
v1 = np.load('o1v.npy')
v2 = np.load('o2v.npy')
v3 = np.load('o3v.npy')

ia1 = np.load('o4i.npy')
ia2 = np.load('o5i.npy')
ia3 = np.load('o6i.npy')
va1 = np.load('o4v.npy')
va2 = np.load('o5v.npy')
va3 = np.load('o6v.npy')

ib1 = np.load('o7i.npy')
ib2 = np.load('o8i.npy')
ib3 = np.load('o9i.npy')
vb1 = np.load('o7v.npy')
vb2 = np.load('o8v.npy')
vb3 = np.load('o9v.npy')

I1rms = rms(i1)
I2rms = rms(i2)
I3rms = rms(i3)

V1rms = rms(v1)
V2rms = rms(v2)
V3rms = rms(v3)

P1 = apower(i1, v1)
P2 = apower(i2, v2)
P3 = apower(i3, v3)
P = P1 + P2 + P3

S1 = I1rms * V1rms
S2 = I2rms * V2rms
S3 = I3rms * V3rms

Ia1rms = rms(ia1)
Ia2rms = rms(ia2)
Ia3rms = rms(ia3)

Va1rms = rms(va1)
Va2rms = rms(va2)
Va3rms = rms(va3)

Sa1 = Ia1rms * Va1rms
Sa2 = Ia2rms * Va2rms
Sa3 = Ia3rms * Va3rms

Pa1 = apower(ia1, va1)
Pa2 = apower(ia2, va2)
Pa3 = apower(ia3, va3)
Pa = Pa1 + Pa2 + Pa3

Ib1rms = rms(ib1)
Ib2rms = rms(ib2)
Ib3rms = rms(ib3)

Vb1rms = rms(vb1)
Vb2rms = rms(vb2)
Vb3rms = rms(vb3)

Sb1 = Ib1rms * Vb1rms
Sb2 = Ib2rms * Vb2rms
Sb3 = Ib3rms * Vb3rms

Pb1 = apower(ib1, vb1)
Pb2 = apower(ib2, vb2)
Pb3 = apower(ib3, vb3)
Pb = Pb1 + Pb2 +Pb3



# printout
print '    formatting tables . . .'

f = open('tables-o-12-pulse.tex', 'w')

# input
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{No load, input}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(V1rms, V2rms, V3rms) + '\n')
f.write(r'$I_{k \, RMS} \; [\text{A}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(I1rms, I2rms, I3rms) + '\n')
f.write(r'$P_k \; [\text{W}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(P1, P2, P3) + '\n')
f.write(r'$S_k \; [\text{VA}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(S1, S2, S3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}

''')
f.write(r'\[ P_{I\!N, \, open} = ' + \
r'{:.2f}'.format(P) + r' \, \text{W} \]' + '\n')

f.write(r''' \bigskip

''')

#f.write(r'\clearpage' + '\n')

# transformer A
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{No load, transformer A}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Va1rms, Va2rms, Va3rms) + '\n')
f.write(r'$I_{T\!A \, k \, RMS} \; [\text{A}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Ia1rms, Ia2rms, Ia3rms) + '\n')
f.write(r'$P_{T\!A \, k} \; [\text{W}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Pa1, Pa2, Pa3) + '\n')
f.write(r'$S_{T\!A \, k} \; [\text{VA}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Sa1, Sa2, Sa3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}

''')
f.write(r'\[ P_{T\!A, \, open} = ' + \
r'{:.2f}'.format(Pa) + r' \, \text{W} \]' + '\n')

f.write(r''' \bigskip

''')

# transformer B
#
f.write(r'''
\begin{table}[h!]
\centering
\caption{No load, transformer B}
\bigskip
\renewcommand{\arraystretch}{1.5}
\begin{tabular}{l|r|r|r}
phase & $1$ & $2$ & $3$ \\
\hline
''')
#
f.write(r'$V_{k \, RMS} \; [\text{V}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Vb1rms, Vb2rms, Vb3rms) + '\n')
f.write(r'$I_{T\!B \, k \, RMS} \; [\text{A}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Ib1rms, Ib2rms, Ib3rms) + '\n')
f.write(r'$P_{T\!B \, k} \; [\text{W}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Pb1, Pb2, Pb3) + '\n')
f.write(r'$S_{T\!B \, k} \; [\text{VA}]$ & ' + \
r'${:.2f}$ & ${:.2f}$ & ${:.2f}$ \\'.format(Sb1, Sb2, Sb3) + '\n')
f.write(r'\hline')
#
f.write(r'''
\end{tabular}
\end{table}

''')
f.write(r'\[ P_{T\!B, \, open} = ' + \
r'{:.2f}'.format(Pb) + r' \, \text{W} \]' + '\n')

f.write('''

''')

f.close()


print '    figures . . .'

# common part

t = linspace(- 10, 10, 2000)
ilim = 3
Vlim = 25

#ind = linspace(0.6, 19.6, 20)
#dcind = linspace(-0.4, 19.6, 21)

#n = 2000 # number of samples
#n2 = n / 2.



# figure params

close('all')

rc('text', usetex=True)
rc('font', family='serif')
rc('font', size = 12)
rcParams['text.latex.preamble']=[r"\usepackage{amsmath}"]

# input

print '        input . . .'

fig = figure(num = 0, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, i1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_1 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 2)
f.plot(t, v1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, i2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_2 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 4)
f.plot(t, v2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, i3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_3 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3, 2, 6)
f.plot(t, v3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig('o-in-waveforms.pdf', bbox_inches='tight')



# transformer A

print '        transformer A . . .'

fig = figure(num = 1, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, ia1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{A1} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 2)
f.plot(t, va1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, ia2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{A2} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 4)
f.plot(t, va2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, ia3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{A3} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3, 2, 6)
f.plot(t, va3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig('o-ta-waveforms.pdf', bbox_inches='tight')



# transformer B

print '        transformer B . . .'

fig = figure(num = 2, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, i1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{B1} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 2)
f.plot(t, v1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, i2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{B2} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 4)
f.plot(t, v2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, i3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{B3} \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3, 2, 6)
f.plot(t, v3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig('o-tb-waveforms.pdf', bbox_inches='tight')

