#! /usr/bin/python

from pylab import *
import sys






# Let's start here!

# specify the measurement
s = sys.argv[1]
what = False
while (not what):
    if   s == 'a':
        ioutstring = r'$I_{OUT} = 0.7 \, \text{A}$'
        ilimind = 0
        what = True
    elif s == 'b':
        ioutstring = r'$I_{OUT} = 1 \, \text{A}$'
        ilimind = 1
        what = True
    elif s == 'c':
        ioutstring = r'$I_{OUT} = 1.5 \, \text{A}$'
        ilimind = 2
        what = True
    elif s == 'd':
        ioutstring = r'$I_{OUT} = 2 \, \text{A}$'
        ilimind = 3
        what = True
    else:
        print 'wrong measurement set "' + s + '", try again with "a", "b", "c", or "d" . . .'
        print
        s = raw_input('measurement set: ')



# common part

t = linspace(- 10, 10, 2000)

ilimbase = (3, 3, 5, 6)
ilim = ilimbase[ilimind]

Vlim = 25

ind = linspace(0.6, 19.6, 20)
dcind = linspace(-0.4, 19.6, 21)
xt = (0, 3, 6, 9, 12, 15, 18)

n = 2000 # number of samples
n2 = n / 2.



print '    initialize . . .'

# figure params

close('all')

rc('text', usetex=True)
rc('font', family='serif')
rc('font', size = 12)
rcParams['text.latex.preamble']=[r"\usepackage{amsmath}"]



# load the data

i1 = np.load(s + '1i.npy')
v11 = np.load(s + '1v.npy')
i2 = np.load(s + '2i.npy')
v21 = np.load(s + '2v.npy')
i3 = np.load(s + '3i.npy')
v31 = np.load(s + '3v.npy')
I1 = abs(fft(i1)) / n2
V11 = abs(fft(v11)) / n2
I2 = abs(fft(i2)) / n2
V21 = abs(fft(v21)) / n2
I3 = abs(fft(i3)) / n2
V31 = abs(fft(v31)) / n2

ita1 = np.load(s + '4i.npy')
v12 = np.load(s + '4v.npy')
ita2 = np.load(s + '5i.npy')
v22 = np.load(s + '5v.npy')
ita3 = np.load(s + '6i.npy')
v32 = np.load(s + '6v.npy')
Ita1 = abs(fft(ita1)) / n2
V12 = abs(fft(v12)) / n2
Ita2 = abs(fft(ita2)) / n2
V22 = abs(fft(v22)) / n2
Ita3 = abs(fft(ita3)) / n2
V32 = abs(fft(v32)) / n2

itb1 = np.load(s + '7i.npy')
v13= np.load(s + '7v.npy')
itb2 = np.load(s + '8i.npy')
v23 = np.load(s + '8v.npy')
itb3 = np.load(s + '9i.npy')
v33 = np.load(s + '9v.npy')
Itb1 = abs(fft(itb1)) / n2
V13 = abs(fft(v13)) / n2
Itb2 = abs(fft(itb1)) / n2
V23 = abs(fft(v23)) / n2
Itb3 = abs(fft(itb1)) / n2
V33 = abs(fft(v33)) / n2

ira1 = np.load(s + '10i.npy')
va1 = np.load(s + '10v.npy')
ira2 = np.load(s + '11i.npy')
va2 = np.load(s + '11v.npy')
ira3 = np.load(s + '12i.npy')
va3 = np.load(s + '12v.npy')
Ira1 = abs(fft(ira1)) / n2
Va1 = abs(fft(va1)) / n2
Ira2 = abs(fft(ira2)) / n2
Va2 = abs(fft(va2)) / n2
Ira3 = abs(fft(ira3)) / n2
Va3 = abs(fft(va3)) / n2

irb1 = np.load(s + '13i.npy')
vb1 = np.load(s + '13v.npy')
irb2 = np.load(s + '14i.npy')
vb2 = np.load(s + '14v.npy')
irb3 = np.load(s + '15i.npy')
vb3 = np.load(s + '15v.npy')
Irb1 = abs(fft(irb1)) / n2
Vb1 = abs(fft(vb1)) / n2
Irb2 = abs(fft(irb2)) / n2
Vb2 = abs(fft(vb2)) / n2
Irb3 = abs(fft(irb3)) / n2
Vb3 = abs(fft(vb3)) / n2

iout1 = np.load(s + '16i.npy')
vouta = np.load(s + '16v.npy')
iout2 = np.load(s + '17i.npy')
voutb = np.load(s + '17v.npy')
iout3 = np.load(s + '18i.npy')
vout = np.load(s + '18v.npy')
Iout1 = abs(fft(iout1)) / n2
Iout1[0] = Iout1[0] / 2
Vouta = abs(fft(vouta)) / n2
Vouta[0] = Vouta[0] / 2
Iout2 = abs(fft(iout2)) / n2
Iout2[0] = Iout2[0] / 2
Voutb = abs(fft(voutb)) / n2
Voutb[0] = Voutb[0] / 2
Iout3 = abs(fft(iout3)) / n2
Iout3[0] = Iout3[0] / 2
Vout = abs(fft(vout)) / n2
Vout[0] = Vout[0] / 2



# figures!



# input
print '    input . . .'

fig = figure(num = 0, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, i1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_1 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 2)
f.plot(t, v11, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, i2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_2 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f = fig.add_subplot(3, 2, 4)
f.plot(t, v21, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, i3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_3 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3, 2, 6)
f.plot(t, v31, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(s + '-in-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 1, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(ind, I1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_1 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, V11[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_1 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, I2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_2 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, V21[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_2 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, I3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_3 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, V31[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_3 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(s + '-in-spectra.pdf', bbox_inches='tight')

# transformer A
print '    transformer A . . .'

fig = figure(num = 2, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, ita1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TA1} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 2)
f.plot(t, v12, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, ita2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TA2} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 4)
f.plot(t, v22, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, ita3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TA3} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.plot(t, v32, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(s + '-ta-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 3, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(ind, Ita1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TA1} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, V12[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_1 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, Ita2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TA2} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, V22[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_2 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, Ita3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TA3} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, V32[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_3 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(s + '-ta-spectra.pdf', bbox_inches='tight')

# transformer B
print '    transformer B . . .'

fig = figure(num = 4, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, itb1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TB1} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 2)
f.plot(t, v13, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, itb2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TB2} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 4)
f.plot(t, v23, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, itb3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{TB3} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.plot(t, v33, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(s + '-tb-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 5, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(ind, Itb1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TB1} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, V13[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_1 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, Itb2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TB2} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, V23[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_2 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, Itb3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{TB3} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, V33[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_3 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(s + '-tb-spectra.pdf', bbox_inches='tight')

# rectifier A
print '    rectifier A . . .'

fig = figure(num = 6, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, ira1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RA1} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 2)
f.plot(t, va1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{A1} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, ira2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RA2} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 4)
f.plot(t, va2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{A2} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, ira3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RA3} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.plot(t, va3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{A3} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(s + '-ra-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 7, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(ind, Ira1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RA1} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, Va1[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{A1} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, Ira2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RA2} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, Va2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{A2} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, Ira3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RA3} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, Va3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{A3} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(s + '-ra-spectra.pdf', bbox_inches='tight')

# rectifier B
print '    rectifier B . . .'

fig = figure(num = 8, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, irb1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RB1} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 2)
f.plot(t, vb1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{B1} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, irb2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RB2} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f = fig.add_subplot(3, 2, 4)
f.plot(t, vb2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{B2} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, irb3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{RB3} \; [\text{A}]$')
f.axis([-10, 10, -ilim / 2.0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.plot(t, vb3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{B3} \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(s + '-rb-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 9, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(ind, Irb1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RB1} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, Vb1[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{B1} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, Irb2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RB2} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, Vb2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{B2} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, Irb3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{RB3} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, Vb3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{B3} \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(s + '-rb-spectra.pdf', bbox_inches='tight')

# output
print '    output . . .'

fig = figure(num = 10, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.plot(t, iout1, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{OUTA} \; [\text{A}]$')
f.axis([-10, 10, 0, ilim / 2.0])

f = fig.add_subplot(3, 2, 2)
f.plot(t, vouta, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{OUTA} \; [\text{V}]$')
f.axis([-10, 10, 0, 3 * Vlim])

f = fig.add_subplot(3, 2, 3)
f.plot(t, iout2, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{OUTB} \; [\text{A}]$')
f.axis([-10, 10, 0, ilim / 2.0])

f = fig.add_subplot(3, 2, 4)
f.plot(t, voutb, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{OUTB} \; [\text{V}]$')
f.axis([-10, 10, 0, 3 * Vlim])

f=fig.add_subplot(3, 2, 5)
f.plot(t, iout3, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_{OUT} \; [\text{A}]$')
f.axis([-10, 10, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.plot(t, vout, 'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_{OUT} \; [\text{V}]$')
f.axis([-10, 10, 0, 3 * Vlim])

savefig(s + '-out-waveforms.pdf', bbox_inches='tight')

fig = figure(num = 11, figsize = (12.5, 10))

f = fig.add_subplot(3, 2, 1)
f.bar(dcind, Iout1[0 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{OUTA} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 2)
f.bar(dcind, Vouta[0 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{OUTA} \; [\text{V}]$')
f.axis([0, 20, 0, 3 * Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(dcind, Iout2[0 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{OUTB} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 4)
f.bar(dcind, Voutb[0 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{OUTB} \; [\text{V}]$')
f.axis([0, 20, 0, 3 * Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(dcind, Iout3[0 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_{OUT} \; [\text{A}]$')
f.axis([0, 20, 0, ilim / 2.0])

f=fig.add_subplot(3, 2, 6)
f.bar(dcind, Vout[0 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_{OUT} \; [\text{V}]$')
f.axis([0, 20, 0, 3 * Vlim])

savefig(s + '-out-spectra.pdf', bbox_inches='tight')

print '    done!'

# show()



