#! /usr/bin/python

import serial
from pylab import *
import sys
import string



# Let's start here

par = sys.argv
if len(par) == 1:
    fn = raw_input('file name: ')
else:
    fn = par[1]



c_probe = 0.1 # V/A

s = serial.Serial(0)
s.timeout = 5

s.write('CH1:COUPling DC;BANdwidth ON;PRObe 1;POSition 0\n')
s.write('CH2:COUPling DC;BANdwidth ON;PRObe 100;POSition 0\n')

s.write('ACQuire:MODe SAMPLE\n')

s.write('TRIGger:MAIn:EDGE:SOUrce LINE\n')
s.write('TRIGger:MAIn:EDGE:SLOpe RISE\n')

s.write('HORizontal:MAIn:SCAle 2.5E-3\n')
s.write('HORizontal:MAIn:POSition 0\n')

v_position = 0.0
h_scale = 2.5e-3
h_position = 0



print 'taking current . . .'

ch = 1
sch = str(ch)
s.write('CH' + sch + ':SCALe?\n')
v_scale = float(s.readline())
s.write('DATa:SOUrce CH' + sch + '\n')
s.write('DATa:ENCdg ASCII\n')
s.write('DATa:STARt 251\n')
s.write('DATa:STOP 2250\n')
s.write('CURVe?\n')
datastring = s.readline()
datalist = datastring.split(',')
ch1 = []
for i in datalist:
    ch1.append((float(i) / 25 - v_position) * v_scale)
ch1 = array(ch1) / c_probe
cmin = ((- 4 - v_position) * v_scale) / c_probe
cmax = ((4 - v_position) * v_scale) / c_probe



print 'taking voltage . . .'

ch = 2
sch = str(ch)
s.write('CH' + sch + ':SCALe?\n')
v_scale = float(s.readline())
s.write('DATa:ENCdg ASCII\n')
s.write('DATa:STARt 251\n')
s.write('DATa:STOP 2250\n')
s.write('DATa:SOUrce CH' + sch + '\n')
s.write('CURVe?\n')
datastring = s.readline()
datalist = datastring.split(',')
ch2 = []
for i in datalist:
    ch2.append((float(i) / 25 - v_position) * v_scale)
ch2 = array(ch2)
vmin=(- 4 - v_position) * v_scale
vmax=(4 - v_position) * v_scale

s.close()


print 'computing . . .'

t=(arange(-4,4,0.004)*h_scale+h_position)*1e3

np.save(fn + 'i.npy', ch1)
np.save(fn + 'v.npy', ch2)



fig = figure(1)

fc = fig.add_subplot(2, 1, 1)
fc.plot(t, ch1)
fc.axis([-10, 10, cmin, cmax])
fc.set_xlabel('time [ms]')
fc.set_ylabel('i [A]')

fv = fig.add_subplot(2, 1, 2)
fv.plot(t, ch2)
fv.axis([-10, 10, vmin, vmax])
fv.set_xlabel('time [ms]')
fv.set_ylabel('v [V]')

show()

